<?php

/**
 * @file
 * Definition of new field used to define refernces information for slugs.
 *
 */

/**
 * Implementation of hook_theme().
 */
function panels_subsites_theme() {
  return array(
    'panels_subsites_ref' => array(
      'arguments' => array(
        'element' => NULL
      ),
    ),
  );
}

/**
 * Theme function to format the our custom form element. We use the
 * container-inline class so that all three of the HTML elements are placed next
 * to each other, rather than on separate lines.
 */
function theme_panels_subsites_ref($element) {
  return theme('form_element', $element, '<div class="panels_subsites_ref">'. $element['#children'] .'</div>');
}

/**
 * Implementation of hook_elements().
 */
function panels_subsites_elements() {
  $types = array();
  $types['panels_subsites_ref'] = array(
    '#input' => TRUE,
    '#process' => array('panels_subsites_ref_element_process'),
    '#element_validate' => array('panels_subsites_ref_element_validate'),
  );
  return $types;
}

/**
 * 
 */
function panels_subsites_ref_element_process($element, $form_state) {
  $element['#tree'] = TRUE;

  // Merge default values into #value
  if (!isset($element['#value'])) {
    $element['#value'] = $element['#default_value'];
  }
  else {
    if (is_array($element['#default_value'])) {
      array_merge($element['#value'], $element['#default_value']);
    }
  }

  // Rule id
  $element['rid'] = array(
    '#type' => 'hidden',
    '#value' => $element['#value']['rid'],
  );

  $element['nodetype'] = array(
    '#type' => 'hidden',
    '#value' => $element['#value']['nodetype'],
  );

  $element['weight'] = array(
    '#type' => 'weight',
    '#title' => t('Weight'),
    '#delta' => 10,
    '#default_value' => $element['#value']['weight'],
  );

  $element['ref'] = array(
    '#type' => 'select',
    '#title' => t('Field'),
    '#options' => $element['#value']['ref_options'],
    '#default_value' => $element['#value']['ref'],
  );

  $element['content_type'] = array(
    '#type' => 'select',
    '#title' => t('Type'),
    '#options' => $element['#value']['content_type_options'],
    '#default_value' => $element['#value']['content_type'],
  );

  return $element;
}

/**
 * 
 */
function panels_subsites_ref_element_validate($element, &$form_state) {
  return $form;
}